# -*- coding: utf-8 -*-
"""
Created on Thu Apr 16 10:28:59 2015

@author: daniel
"""

def do_defaulting_english(bin_size = 2, file = 'becky-36', threshold = 0.65):
    print 'file is', file
    #threshold = 0.65
    defaulting_count,third_count = 0, 0
    in_list, out_list = [], []
    print "bin-size is", bin_size, "theshold is", threshold
    counts_dict = get_verb_counts('verb-counts-english', bin_size)
    #print counts_dict['STAMPS']
    print "in-file is", file
    if '.json' in file:
        with open(output_dir + file, 'r') as infile:
            in_list = byteify(json.load(infile))
    else:
        with open(output_dir + file, 'rb') as csvfile:
            reader = csv.reader(csvfile, delimiter=',')
            for row in reader:
                in_list.append(row)
    print(len(in_list))
    for line in in_list:
        #print "line", line
        my_line = line[1].split()
        #print my_line
        for i in range(len(my_line)):
            word = my_line[i]
            #if word in dict:
            #    print word
            #print word, strip_end(word, '-3RD')
            if ('-3RD' in word and
                strip_end(word, '-3RD') in counts_dict):
                counts = counts_dict[strip_end(word, '-3RD')]
                third_count +=1
                #print "third", line, third_count
                nums = [int(item[1]) for item in counts]
                #print word,counts,nums
                total = sum(nums)
                #print total
                for item in counts:
                    if (total > 0 and
                        item != counts[1] and
                        (float(item[1]) / total) > threshold):
                        print "default", item
                        if item[0] != strip_end(word, '-3RD'):
                            my_line[i] = item[0] + '-3RD'
                            defaulting_count += 1
                            print "defaulted", my_line, defaulting_count
            #if ('-3RD' in word and
            #    strip_end(word, '-3RD') not in counts_dict):
            #        print "summat wrong", word, line
        line[1] = ' ' .join(my_line)
        out_list.append(line)
    print "third singulars", third_count
    print "defaulted items", defaulting_count
    with open(output_dir + 'temp.txt', "wb") as f:
        writer = csv.writer(f)
        writer.writerows(out_list)
    result = analyse_3rd_english('temp.txt') + [defaulting_count]
    result[0] = file + '-def'
    return result

def do_defaulting_dutch(bin = 10, infile = 'pet-40-sb.json', threshold = 0.65):
    #threshold = 0.65
    collecting = 'false'
    defaults_dict = {}
    counts_dict = get_verb_counts('verb-counts-dutch', bin)
    #for item in counts_dict:
    #    print item, counts_dict[item]
    inlist = byteify(json.load(open(output_dir + infile, 'r')))
    print len(inlist)
    print inlist[1]
    defaulting_count = 0
    outlist = []
    #inlist = inlist[:100]
    for line in inlist:
        my_line = line[1].split()
        #print my_line
        for i in range(len(my_line)):
            if (my_line[i] in counts_dict and
                my_line[i] not in ['HOOR', 'KIJK', 'WAS', 'ZIJN', 'IS']):
                #print my_line[i], counts_dict[my_line[i]]
                counts = counts_dict[my_line[i]]
                #print my_line[i], counts
                tot = 0
                for item in counts:
                    if len(item) == 2:
                        #print "count item", item
                        tot +=int(item[1])
                for item in counts:
                    if (len(item) == 2 and
                        #my_line[i] !=counts[0][0] and
                        int(item[1])/tot > threshold and
                        #item[0]
                        item[0] != my_line[i]
                        ):
                        #print "default", item, my_line, counts
                        #print "check", my_line[i], counts[0][0], item[0]


                        if (my_line[i] == counts[0][0] and
                            my_line[i] != item[0]):
                            print "defaulting from inf:",  item, my_line, counts
                        defaulting_count +=1
                        my_line[i] = item[0]
        if my_line != line[1].split():
            line[0] = 'def'
            line[1] = ' '.join(my_line)
        outlist.append(line)
    outfile = 'dutch-defs.txt'
    print "defaults", defaulting_count
    print "outfile =", output_dir + outfile
    with open(output_dir + outfile, "wb") as f:
        writer = csv.writer(f)
        writer.writerows(inlist)
    return [infile] + analyse_dutch('dutch-defs.txt')[1:] + [defaulting_count]
    #print "defaults", defaulting_count

def do_defaulting_spanish(bin = 2, infile = 'juan-36-sb.json', threshold = 0.65):
    #threshold = 0.65
    collecting = 'false'
    #counts_dict = get_verb_counts('verb-counts-spanish-j+l+f-a-utf', bin)
    counts_dict = get_verb_counts('verb-counts-spanish-new.txt', bin)
    print len(counts_dict)
    #for item in counts_dict:
    #    print item
    print counts_dict['PASAR']
    inlist = byteify(json.load(open(output_dir + infile, 'r')))
    print len(inlist), inlist[0]
    #inlist = inlist[:100]
    outlist = []
    defaulting_count = 0
    for line in inlist:
        my_line = line[1].split()
        for i in range(len(my_line)):
            if my_line[i] in counts_dict:
                #print "counts", counts_dict[my_line[i]]
                counts = counts_dict[my_line[i]]
                tot = 0
                for item in counts:
                    if len(item) > 1:
                        tot += int(item[1])
                #print my_line[i], counts, tot
                for item in counts:
                    if (tot > 0 and
                        len(item) > 1 and
                        int(item[1])/tot > threshold and
                        item[0] != my_line[i] and
                        my_line[i] != counts[0][0] and
                        #counts):
                        counts[0][0] not in ['ESTAR', 'SER', 'HABER'] and
                        my_line[i] not in ['HAY', 'NADAR', 'COMO', 'PARA']):
                        print "defaulting", my_line[i], "to", item
                        #print item, counts[0], counts[0]
                        my_line[i] = item[0]
                        #print "defaulted", my_line
                        defaulting_count +=1
            if my_line != line[1].split():
                line[0] = 'def'
                line[1] = ' '.join(my_line)
            outlist.append(line)
    print "done"
    outfile = 'spanish-defs.txt'
    print "defaults", defaulting_count
    print "outfile =", output_dir + outfile
    with open(output_dir + outfile, "wb") as f:
        writer = csv.writer(f)
        writer.writerows(inlist)
    return [infile] + analyse_spanish('spanish-defs.txt')[1:] + [defaulting_count]
    #print "defaults", defaulting_count


def do_defaulting_german(bin = 10, infile = 'leo-52-sb.json'):
    threshold = 0.65
    collecting = 'false'
    defaults_dict = {}
    file = open('/users/daniel/desktop/pycharm projects/mosaic/german-defaults.json')
    inlist = byteify(json.load(file))
    print len(inlist)
    for line in inlist:
        if line == ["bin is " + str(bin)]:
            collecting = 'true'
        if line == ["bin is " + str(bin + 1)]:
            collecting = 'false'
        if (collecting == 'true' and
            len(line) > 1):
            for item in line[2]:
                #print item
                if (len(item) > 0 and
                    line[1] > 0 and
                    item[1]/line[1] >= threshold):
                        for i in range(len(line[2])):
                            word = line[2][i]
                            if (len(word) > 0 and
                                i != 3 and
                                word[0] != item[0]):
                                #print "defaulting", line
                                #print word[0], item[0]
                                defaults_dict[convert_umlauts(word[0])] = convert_umlauts(item[0])
                        #print len(defaults_dict)
    print "done"
    print "defaults", len(defaults_dict)
    #for item in defaults_dict:
    #    print item, defaults_dict[item]
    inlist = byteify(json.load(open(output_dir + infile)))
    print len(inlist)
    #with open(output_dir + infile, 'rb') as csvfile:
    #    reader = csv.reader(csvfile, delimiter=',')
    #    for row in reader:
    #        inlist.append(row)
    print len(inlist)
    print inlist[1], len(inlist[1])
    #inlist = inlist[10:]
    print len(inlist)
    defaulting_count = 0
    for line in inlist:
        #print line
        my_line = line[1].split()
        #print my_line
        for i in range(len(my_line)):
            if my_line[i] in defaults_dict:
                defaulting_count +=1
                print "defaulting", my_line[i], "to", defaults_dict[my_line[i]]
                #print line, '\n'
                my_line[i] = defaults_dict[my_line[i]]
                line[1] = ' '.join(my_line)
                line[0] = line[0] + 'DEF'
    outfile = 'german-defs.txt'
    print "defaults", defaulting_count
    print "outfile =", output_dir + outfile
    with open(output_dir + outfile, "wb") as f:
        writer = csv.writer(f)
        writer.writerows(inlist)
    return [infile] + analyse_german('german-defs.txt')[1:] + [defaulting_count]



#def convert_umlauts(str):
#    new = ''
#    str = str.decode('utf-8')
#    for char in str:
#        if char == u'ä':
#            new = new + 'ae'
#        elif char == u'ö':
#            new =  new + 'oe'
#        elif char == u'ü':
#            new = new + 'ue'
#        elif char == u'ß':
#            new = new + 'ss'
#        else:
#            new = new + char
#    #print new
#    return new.upper()

def map_n(list, n):
    out_list = []
    for item in list:
        out_list.append(item[n])
    return out_list

#def has_default(key, threshold)

def strip_end(text, suffix):
    if not text.endswith(suffix):
        return text
    return text[:len(text)-len(suffix)]

def get_verb_counts(file, bin):
    bin_size = bin
    collecting = 'false'
    counts = []
    dict = {}
    print "counts", counts
    dir = '/users/daniel/desktop/pycharm projects/mosaic/input/verb-counts/'
    in_file = open(dir + file, 'r')
    #in_file = open('/users/daniel/desktop/test.txt', 'r')
    in_list = in_file.read().splitlines()
    for i in range(len(in_list)):
        line = in_list[i].split()
        #rint line
        if "bin-size" in line[0]:
            if int(line[1]) == bin_size:
                print "bin_size is", line[1]
                collecting = 'true'
            else:
                print "not collecting, bin-size is", line[1]
                collecting = 'false'
        if (collecting == 'true' and
            "bin-size" not in line[0] and
            line not in ['((', '))']):
                #print "trying", line, collecting
                my_line = line_to_list(line)
                if my_line not in counts:
                    counts.append(my_line)
    for line in counts:
        for word in line:
            dict[word[0]] = line
    if len(counts) > 1:
        for item in counts[0]:
            print item, item[0]
    return dict


def line_to_list(line):
    out_line = []
    #print "ltl, in_line", line
    #line = line.split()
    #print "split_line", line
    line = line[1:]
    #print "rest", line
    for item in line:
        #print "item", item
        out_string = ''
        if ('[' in item or
            '(' in item):
            out_item = []
        for i in range(len(item)):
            if item[i] not in ['(', ')', '"', '[', ']']:
                out_string = out_string + item[i]
        out_item.append(out_string)
        if (']' in item or
            ')' in item):
            out_line.append(out_item)
    #print "out_line", out_line
    return out_line

#def collate_counts_english()
#    threshold = 0.65
#    bins = [1]
#
#    dir = '/users/daniel/desktop/pycharm projects/mosaic/input/verb-counts/'
#    file = dir + "verb_counts_english"
#    for bin in bins:
#        counts_dict = get_verb_counts(file, bin)
#    print len(counts_dict)